#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

sub read_config {
	my ($fname, $on_line_slot, @options) = @_;
	my $line;
	my @res=();

	open(GCONF, $fname) or die("unable to read config file: ".$fname);
	while($line= <GCONF>) {
		chomp $line;
		if( !($line =~ /^[ \t]*#/) && $line ne "") {
			&{$on_line_slot}($line, \@res, @options);
		}
	}
	close(GCONF);

	return @res;
}

sub read_config_from
{
	my ($fname, @options) = @_;

	return read_config($fname, \&on_option_line, @options);
}

sub on_option_line
{
	my ($line, $res, @options) = @_;
	my ($j, $n);
	
	my $found=1;
	$found=0 if($#options>=0);
	for($j=0; $j<=$#options && $found==0; $j++) {
		$n=$options[$j];
		if( $line =~ /^[ \t]*$n[ \t]*=[ \t]*(.*)/ ) {
			$$res[$j]=$1;
			$found=1;
		}
	}
	if($found==0) {
		die("invalid config line: ".$line.". ");
	}
}

1;
