#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

sub on_start
{
	run_handlers("start", @_);
}

sub on_connect
{
	run_handlers("servans", "connect", @_);
	my $conn=shift;
	my ($chan, $c);

	
	nickserv_ident($conn, $nickserv_pass);
}

sub on_nick_in_use
{
	run_handlers("servans", "nick_in_use", @_);
	my ($conn, $event) = @_;
	
	$nick.="_";
	$conn->nick($nick);
}

sub on_identified
{
	run_handlers("servans", "identified", @_);
	my ($conn) = @_;
	my ($c, $s);

	foreach my $chan (split(/,/, $channels)) {
		$c=""; $s=1;
		$chan=$1 if($chan =~ /^[\t ]*(.*)/);
		if($chan =~ /^i(.*)/) {
			$c=$1;
			$s=0 if(chanserv_invite($conn, $c)==0);
		}
		if($c eq "") {
			print "Joining $chan..\n";
			$conn->join($chan, "");
		} elsif($s==0) {
			print "Joining $c..\n";
			$conn->join($c, "");
		}
	}
	# only for debug
	# $conn->privmsg("chanserv", "op");
}

sub on_timer
{
	my $conn=$_[0];
	my $now=time();
	
		# check services status if needed
	check_serv($conn) if($services_up==0);
		# check connection timout
	run_handlers("conntimeout", $conn, $now-$last_servans) if($now-$last_servans > $MAX_CONN_TIMEOUT);
	ping_serv($conn) if($now-$last_servans > $MAX_CONN_TIMEOUT/2);
	run_handlers("timer", @_);
}

	# on any server answer
sub on_servans
{
	my $conn=$_[1];
	my $now=time();
	
	$last_servans=$now;
	print "[".localtime()."] servans: ".$_[0]."\n";
}

	# Auto-rejoin on kick
sub on_kick {
	run_handlers("servans", "kick", @_);
	my $conn=shift;
	my $event=shift;
	my @stuff=$event->args;
	my $chan=$stuff[0];

	if($event->{to}[0] eq $nick) {
		print "kicked from ".$chan." rejoin...\n";
		$conn->join($chan, $chankey);
	} else {
		userlist_on_kick($conn, $event, @_);
	}
	run_handlers("kick", $conn, $event, @_);
}

	# join chan if I am invited (and if it's in my chan list)
sub on_invite {
	run_handlers("servans", "invite", @_);
	my $conn=shift;
	my $event=shift;
	my $dest = $event->{args}[0];
	my $ch;
	
	foreach my $chan (split(/,/, $channels)) {
		$ch=$chan;
		$ch =~ s/\s+$//g;
		$ch =~ s/^\s+//g;
		if($ch =~ /^i(.*)/) {
			$ch=$1;
		}
		if( $ch eq $dest) {
			print "Joining $ch (invited)..\n";
			$conn->join($ch, "");
		}
	}
	run_handlers("invite", $conn, $event, @_);
}

	# event recieved by server (and not by a run_handlers)
sub on_disconnect {
	my $conn=shift;
	my $event=shift;

	print "Disconnected (".($event->args())[0].")...attempting to reconnect...\n";
	run_handlers("disconnect", $conn, $event, @_);
	run_handlers("reconnect", $conn, @_);
}

sub on_conntimeout
{
	my ($conn, $time) = @_;
	
	print "Disconnected (Connection timeout, no activity for ".$time."s)...attempting to reconnect...\n";
	run_handlers("disconnect", $conn, @_);
	run_handlers("reconnect", $conn, @_);
}

sub on_reconnect {
	my ($conn) = @_;
	
	$services_up=1;
	$op_on_auth=0;
	do {
		sleep(10);
		$conn->connect();
	} while($self->{'iserror'});
	print "Reconnection successfull\n";
}

	# somebody says something :) (channel or query)
sub on_msg {
	run_handlers("servans", "msg", @_);
	my ($conn, $event) = @_;
	my $text = $event->{args}[0];
	
	my $nick = $event->nick;
	my $chan = $event->to;

	on_command($conn, $nick, $chan, $text);
	run_handlers("msg", @_);
}

sub on_command {
	my ($conn, $nick, $chan, $text) = @_;
	my ($i, $j, $n);

	$text =~ s/\s+$/ /g;
	my @tarr=split(/ /, $text);
	my $cmd=shift(@tarr);
	my $args=join(' ', @tarr);
	my @taar;
	#if($cmd =~ /(.*)-here$/) {
	#	$cmd=$1;
	#	$nick=$chan;
	#}
	if($cmd =~ /(.*)-to$/ && !($tarr[0] =~ /^[#&]/)) {
		$cmd=$1;
		$nick=shift(@tarr);
		$args=join(' ', @tarr);
	}
	for($i=0; $i<=$#aliases; $i++) {
		if( $aliases[$i][$CMD_ID] eq $cmd ) {
			@taar=split(/ /, $aliases[$i][$CMD_NAME]);
			$cmd=shift(@taar);
			$args=join(' ', @taar)." ".$args;
		}
	}
	$n=0;
	for($i=0; $i<=$#commands; $i++) {
		if( $commands[$i][$CMD_NAME] eq $cmd ) {
			for($j=0; $j<=$#COMMANDST; $j++) {
				if($COMMANDST[$j][$CMDS_NAME] eq $commands[$i][$CMD_ID]) {
					print "[".localtime()."] ".$nick." running '".$cmd."'\n" if($n==0);
					&{$COMMANDST[$j][$CMDS_FUNC]}($conn, $nick, $args);
					$n++;
				}
			}
		}
	}
	sleep(2);
}

sub on_unhandled
{
#	can't say it's a server answer... because this event could be called during a conn timeout
#	run_handlers("servans", "unhandled", @_);

	my ($conn, $event) = @_;

	if($event->{args}[2] eq "Services is currently down. Please wait a few moments, and then try again.") {
		on_services_err($conn, $event);
	} else {
		print "unhandled event: ".$event->{args}[2]."\n";
	}
}

sub on_notice
{
	run_handlers("servans", "notice", @_);
	my ($conn, $event) = @_;
	
	print "[".localtime()."] ".$event->{args}[0]."\n";
	if(is_nickserv($event->nick)) {
		on_nickserv($conn, $event);
	}
}

sub on_whoisidle
{
	run_handlers("servans", "whoisidle", @_);
	my ($conn, $event) = @_;
	
	run_handlers("whoisidle", $conn, $event->{args}[1], $event->{args}[2]);
}

sub on_auth
{
	my ($conn, $event) = @_;

	if($op_on_auth==1) {
		$op_on_auth=0;
		mode_push("+o", $event->{args}[0]);
		mode_push("-o", pop(@deopchan_on_op)) if($#deopchan_on_op>=0);
		mode_sync($conn, $opchan_on_auth);
	}
}

sub on_version
{
	run_handlers("servans", "version", @_);
	my ($conn, $event) = @_;
	
	$conn->ctcp_reply($event->nick, $VERSION_REPLY);
}

1;
