#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

my $NICKSERV_CMD = "NICKSERV";
my $CHANSERV_CMD = "CHANSERV";

my $identifying=0;

sub nickserv_status_nick
{
	my ($conn, $nick) = @_;
	
	return nickserv($conn, "status ".$nick);
}

sub nickserv_ident
{
	my ($conn, $pass) = @_;

	$identifying=1;
	if(nickserv($conn, "identify ".$pass)==0) {
		$identifying=0;
		on_identified($conn);
		return 0;
	}
	print "waiting for authentification...\n";
	return 1;
}

sub chanserv_invite
{
	my ($conn, $chan) = @_;
	
	return chanserv($conn, "invite ".$chan);
}

sub nickserv
{
	my ($conn, $text) = @_;
	
		# 'NICKSERV' is more standart than 'PRIVMSG nickserv'
	$conn->sl($NICKSERV_CMD." ".$text) if($services_up==1);
	return $services_up;
}

sub is_nickserv
{
	return ($_[0] eq $nickserv);
}

sub chanserv
{
	my ($conn, $text) = @_;
	
	$conn->sl($CHANSERV_CMD." ".$text) if($services_up);
	return $services_up;
}

sub chanserv_get_op
{
	my ($conn, $chan) = @_;
	
	return chanserv($conn, "op ".$chan);
}

sub check_serv
{
	my ($conn) = @_;

		# works even if nickserv hasn't the name 'nickserv'.
	$conn->sl($NICKSERV_CMD." status nickserv");
		# see auth.ph too
}

sub ping_serv
{
	my ($conn) = @_;
	
	privmsg($conn, $nick, "test");
}

sub on_services_err
{
	my ($conn, $event) = @_;
	
	return if($services_up==0);
	$services_up=0;
	if($identifying==1) {
		$identifying=0;
		on_identified($conn);
	}
	print "Error: services not available\n";
	run_handlers("servans", "services_down", @_);
	run_handlers("services_down", @_);
}

sub on_nickserv
{
	my ($conn, $event) = @_;
	
	$services_up=1;
	for($i=0; $i<=$#SERVANS; $i++) {
		if($event->{args}[0] =~ $SERVANS[$i][$SERV_TEXT]) {
			&{$SERVANS[$i][$SERV_FUNC]}($conn, $event, $1, $2, $3, $4, $5);
		}
	}
	
	run_handlers("nickserv", $conn, $event);
}

1;
