#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

sub on_names
{
	run_handlers("servans", "names", @_);
	my @args=@_;
	my ($i, $j, $c);

	for($i=0; $i<=$#userlist; $i++) {
		if($userlist[$i][$USERL_CHAN] eq $args[1]->{args}[2]) {
				# purge nick list if needed, for this chan
			if($userlist[$i][$USERL_ENDED] eq "" || $userlist[$i][$USERL_ENDED]==1) {
				$userlist[$i][$USERL_NICKS]=();
				
				print "[".localtime()."] "."purging nick list for chan ".$args[1]->{args}[2]."\n";
			}
			last;
		}
	}
	$userlist[$i][$USERL_ENDED]=0;
	
	print "[".localtime()."] "."adding chan ".$args[1]->{args}[2]." at offset ".$i." (";
	$userlist[$i][$USERL_CHAN]=$args[1]->{args}[2];
	$c=$#{$userlist[$i][$USERL_NICKS]}+1;
	my @u=split(/ /, $args[1]->{args}[3]);
	for($j=0; $j<=$#u; $j++) {
		$userlist[$i][$USERL_NICKS][$c][$USERL_NICK]=$u[$j];
		$userlist[$i][$USERL_NICKS][$c][$USERL_FLAGS]=0;
		if($u[$j] =~ /^@(.*)/) {
			$userlist[$i][$USERL_NICKS][$c][$USERL_NICK]=$1;
			$userlist[$i][$USERL_NICKS][$c][$USERL_FLAGS]=$USER_OP;
		} elsif($u[$j] =~ /^\+(.*)/) {
			$userlist[$i][$USERL_NICKS][$c][$USERL_NICK]=$1;
			$userlist[$i][$USERL_NICKS][$c][$USERL_FLAGS]=$USER_VOICE;
		}
		print $userlist[$i][$USERL_NICKS][$c][$USERL_NICK]." ";
		$c++;
	}
	print ")\n";
	run_handlers("namreply", @args);
}

sub on_endofnames
{
	run_handlers("servans", "endofnames", @_);
	my ($conn, $events) = @_;
	my $i;
	my $chan=$events->{args}[1];

	for($i=0; $i<=$#userlist; $i++) {
		if($userlist[$i][$USERL_CHAN] eq $chan) {
			$userlist[$i][$USERL_ENDED]=1;
			return;
		}
	}
	run_handlers("endofnames", $conn, $events);
}

sub userlist_on_kick
{
	userlist_del($_[0], $_[1]->{args}[0], $_[1]->{to}[0]);
}

sub on_part
{
	run_handlers("servans", "part", @_);
	userlist_del($_[0], $_[1]->{to}[0], $_[1]->nick);
	run_handlers("part", @_);
}

sub on_nick
{
	run_handlers("servans", "nick", @_);
	userlist_ren($_[0], $_[1]->nick, $_[1]->{args}[0]);
	users_on_nick(@_);
	run_handlers("nick", @_);
}


sub on_quit
{
	run_handlers("servans", "quit", @_);
	my $n=$_[1]->nick;
	my $i;
	
	for($i=0; $i<=$#userlist; $i++) {
		userlist_del($_[0], $userlist[$i][$USERL_CHAN], $n);
	}
	users_on_quit(@_);
	run_handlers("quit", @_);
}

sub on_join
{
	run_handlers("servans", "join", @_);
	my @args=@_;
	if($args[1]->nick eq $nick) {
		on_my_join(@args);
		run_handlers("my_join", @args);
	} else {
		userlist_add($args[0], $args[1]->{to}[0], $args[1]->nick);
		users_on_join(@args);
		run_handlers("join", @args);
	}
}

sub on_mode
{
	run_handlers("servans", "mode", @_);
	my @args=$_[1]->args;

	my $mode=shift(@args);
	userlist_set($_[0], $_[1]->{to}[0], $mode, @args);
	run_handlers("mode", @_);
}

sub userlist_add
{
	my ($conn, $chan, $nick) = @_;
	my ($i, $c);

	print "[".localtime()."] ".$chan.": ".$nick." joins\n";
	for($i=0; $i<=$#userlist; $i++) {
		if($userlist[$i][$USERL_CHAN] eq $chan) {
			$c=$#{$userlist[$i][$USERL_NICKS]};
			$userlist[$i][$USERL_NICKS][$c+1][$USERL_NICK]=$nick;
			$userlist[$i][$USERL_NICKS][$c+1][$USERL_FLAGS]=0;
			run_handlers("userlist_add", $conn, $chan, $nick);
			return;
		}
	}
}

sub userlist_del
{
	my ($conn, $chan, $nick) = @_;
	my ($i, $j, $fl);

	print "[".localtime()."] ".$chan.": ".$nick." has quit\n";
	for($i=0; $i<=$#userlist; $i++) {
		if($userlist[$i][$USERL_CHAN] eq $chan) {
			for($j=0; $j<=$#{$userlist[$i][$USERL_NICKS]}; $j++) {
				if($userlist[$i][$USERL_NICKS][$j][$USERL_NICK] eq $nick) {
					$fl=$userlist[$i][$USERL_NICKS][$j][$USERL_FLAGS];
					splice(@{$userlist[$i][$USERL_NICKS]}, $j, 1);
					run_handlers("userlist_del", $conn, $chan, $nick, $fl);
					return;
				}
			}
		}
	}
}

sub userlist_ren
{
	my ($conn, $oldnick, $nick) = @_;
	my ($i, $j);

	print "[".localtime()."] ".$oldnick." renamed to ".$nick."\n";
	for($i=0; $i<=$#userlist; $i++) {
		for($j=0; $j<=$#{$userlist[$i][$USERL_NICKS]}; $j++) {
			if($userlist[$i][$USERL_NICKS][$j][$USERL_NICK] eq $oldnick) {
				$userlist[$i][$USERL_NICKS][$j][$USERL_NICK]=$nick;
			}
		}
	}
	run_handlers("userlist_ren", $conn, $oldnick, $nick);
}


sub userlist_set
{
	my ($conn, $chan, $mode, @nicks) = @_;
	my ($i, $j, $m, $s, $c);

	print "[".localtime()."] ".$chan.": set ".$mode." to ".join(' ', @nicks)."\n";
	if($#nicks==-1 || $nicks[0] eq "") {
		print "[".localtime()."] "."mode on chan\n";
		return;
	}
	$c=0;
	for($i=0; $i<=$#userlist; $i++) {
		if($userlist[$i][$USERL_CHAN] eq $chan) {
			$m=$mode;
			while($m ne "") {
				if($m =~ /^\+(.*)/) {
					$m=$1;
					$s=1;
				} elsif($m =~ /^\-(.*)/) {
					$m=$1;
					$s=0;
				}
				for($j=0; $j<=$#{$userlist[$i][$USERL_NICKS]}; $j++) {
					if($userlist[$i][$USERL_NICKS][$j][$USERL_NICK] eq $nicks[$c]) {
						if($m =~ /^o/) {
							if($nicks[$c] eq $nick && $s==0
							 && $userlist[$i][$USERL_NICKS][$j][$USERL_FLAGS]==$USER_OP) {
								print "[".localtime()."] "."deopped...";
								if(!chanserv_get_op($conn, $chan)) {
									print "please op me !";
									privmsg($conn, $chan, "!op");
								}
								print "\n";
							}
							$userlist[$i][$USERL_NICKS][$j][$USERL_FLAGS]=($s==1?$USER_OP:0);
							print "[".localtime()."] (o) ".$userlist[$i][$USERL_NICKS][$j][$USERL_NICK]." now has flag ".$userlist[$i][$USERL_NICKS][$j][$USERL_FLAGS]."\n";
						} elsif($m =~ /^v/) {
							$userlist[$i][$USERL_NICKS][$j][$USERL_FLAGS]=($s==1?$USER_VOICE:0);
							print "[".localtime()."] (v) ".$userlist[$i][$USERL_NICKS][$j][$USERL_NICK]." now has flag ".$userlist[$i][$USERL_NICKS][$j][$USERL_FLAGS]."\n";
						}
						$c++;
						last;
					}
				}
					# even if we don't find the nick, forgot this mode
				$m =~ s/^.(.*)/$1/;
			}
		}
	}
	run_handlers("userlist_set", $conn, $chan, $mode, @nicks);
}

sub userlist_getops
{
		# returns ops, except myself (and bots)
	my ($chan) = @_;
	my (@res, $i, $j, $k, $s);
	@res=();
	
	for($i=0; $i<=$#userlist; $i++) {
		if($userlist[$i][$USERL_CHAN] eq $chan) {
			for($j=0; $j<=$#{$userlist[$i][$USERL_NICKS]}; $j++) {
				if($userlist[$i][$USERL_NICKS][$j][$USERL_FLAGS]==$USER_OP
				 && $userlist[$i][$USERL_NICKS][$j][$USERL_NICK] ne $nick) {
				 	$s=0;
					for($k=0; $k<=$#bots; $k++) {
						$s=1 if($bots[$k] eq $userlist[$i][$USERL_NICKS][$j][$USERL_NICK]);
					}
					push(@res, $userlist[$i][$USERL_NICKS][$j][$USERL_NICK]) if($s==0);
				}
			}
		}
	}
	return @res;
}

sub userlist_getnonops
{
		# returns non ops, except myself
	my ($chan) = @_;
	my (@res, $i, $j);
	@res=();
	
	for($i=0; $i<=$#userlist; $i++) {
		if($userlist[$i][$USERL_CHAN] eq $chan) {
			for($j=0; $j<=$#{$userlist[$i][$USERL_NICKS]}; $j++) {
				if($userlist[$i][$USERL_NICKS][$j][$USERL_FLAGS]!=$USER_OP
					&& $userlist[$i][$USERL_NICKS][$j][$USERL_NICK] ne $nick) {
					push(@res, $userlist[$i][$USERL_NICKS][$j][$USERL_NICK]) 
				}
			}
		}
	}
	return @res;
}


1;
