#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

my $SERV_MIN_STATUS_LEVEL	= 3;

sub users_on_option_line
{
	my ($line, $res) = @_;
	my ($login, @l, @n, @h);
	
	$line =~ s/\s+//g;
	if( $line =~ /^[ \t]*(.*)[ \t]*=[ \t]*(.*)/ ) {
		$login=$1;
		@l=split(/@/, $2);
		@n=split(/;/, $l[0]);
		@h=split(/;/, $l[1]);
		push(@users, ([$login, [@n], [@h], []]));
	}
}


sub on_my_join
{
	my ($conn, $event) = @_;
	
	$conn->who($event->{to}[0]);
}

sub on_whoreply
{
	# turns up ident procedure
	my $nck=$_[1]->{args}[5];
	
	return if($nck eq $nick);
	my ($l, $n) = users_getuser($nck);
	
		# nick not found, can be new user (who on my_join)
	if($l==-1) {
		my $l = users_getnewuser($nck);
			# really not found
		return if($l==-1);
		print "[".localtime()."] [who] ".$nck." pre-identified by nick, added to list\n";
#     sol 1: n'ajouter que si ident != 0
#     sol 2: supprimer si ident ==0
# --> sol 3: gerer bien les nicks avec ident=0
		push(@{$users[$l][$USERS_CURRENT]}, ([$nck, 0]) );
		$n=$#{$users[$l][$USERS_CURRENT]};
	}
	auth_user($_[0], $l, $n, $nck, $_[1]->{args}[3]);
}


sub users_on_nick
{
	my (@args) = @_;
	my $conn=$args[0];
	my $oldn=$args[1]->nick;
	my $newn=$args[1]->{args}[0];
	my ($l, $n) = users_getuser($oldn);
	my $i;
	
	if($l==-1 || $n==-1) {
			# who lauches auth
		$conn->who($newn);
		return;
	}
	$users[$l][$USERS_CURRENT][$n][$USERS_CNICK]=$newn;
		# just verify if we must add this nick to nick list
	for($i=0; $i<=$#{$users[$l][$USERS_NICKS]}; $i++) {
		return if($newn =~ /$users[$l][$USERS_NICKS][$i]/);
	}
		# don't need to add the nick to the list if ident=0 !
	if($users[$l][$USERS_CURRENT][$n][$USERS_CIDENT]==0) {
		print "[".localtime()."] "."NO need to add nick ".$newn." to login ".$users[$l][$USERS_LOGIN].": not identified\n";
		return;
	}
	print "[".localtime()."] "."need to add nick ".$newn." to login ".$users[$l][$USERS_LOGIN]."\n";
	push(@{$users[$l][$USERS_NICKS]}, "^\Q$newn\E\$");
}


sub users_on_quit
{
	my ($l, $n) =users_getuser($_[1]->nick);
	
	return if($l==-1 || $n==-1);
	print "[".localtime()."] "."nick ".$users[$l][$USERS_CURRENT][$n][$USERS_CNICK]." (ident=".$users[$l][$USERS_CURRENT][$n][$USERS_CIDENT].") deleted\n";
	splice(@{$users[$l][$USERS_CURRENT]}, $n, 1);
}

sub users_on_join
{
		# turns up ident procedure
	my $nick=$_[1]->nick;
	my $l = users_getnewuser($nick);

	return if($l==-1);
	print "[".localtime()."] ".$nick." pre-identified by nick, added to list\n";
	push(@{$users[$l][$USERS_CURRENT]}, ([$nick, 0]) );
	auth_user($_[0], $l, $#{$users[$l][$USERS_CURRENT]}, $nick, $_[1]->host);
}

sub users_getnewuser
{
	my ($nick) = @_;
	my ($i, $j);

		# find login offset corresponding to this nick
	for($i=0; $i<=$#users; $i++) {
		for($j=0; $j<=$#{$users[$i][$USERS_NICKS]}; $j++) {
print "debug - $nick =~ /$users[$i][$USERS_NICKS][$j]/\n";
			return $i if($nick =~ /$users[$i][$USERS_NICKS][$j]/);
		}
	}
	return -1;
}

sub users_getuser
{
	my ($nick) = @_;
	my ($i, $j);

	return (-1, -1) if($nick eq "");
		# find login offset corresponding to this nick
	for($i=0; $i<=$#users; $i++) {
		for($j=0; $j<=$#{$users[$i][$USERS_CURRENT]}; $j++) {
			return ($i, $j) if($nick eq $users[$i][$USERS_CURRENT][$j][$USERS_CNICK]);
		}
	}
	return (-1, -1);
}


sub users_get_authlogin
{
	my ($nick) = @_;
	
	my ($l, $n) = users_getuser($nick);
	return "/" if($l==-1 || $users[$l][$USERS_CURRENT][$n][$USERS_CIDENT]==0);
	return $users[$l][$USERS_LOGIN];
}

sub auth_user
{
	my ($conn, $l, $n, $nick, $host) = @_;

	auth_user_byhost($l, $n, $nick, $host);
	auth_user_byserv($conn, $nick);
}

sub auth_user_byhost
{
	my ($l, $n, $nick, $host) = @_;
	my $i;

	for($i=0; $i<=$#{$users[$l][$USERS_HOSTS]}; $i++) {
		if($host =~ $users[$l][$USERS_HOSTS][$i]) {
			$users[$l][$USERS_CURRENT][$n][$USERS_CIDENT]=$IDENT_BYHOST;
			print "[".localtime()."] "."user ".$nick."@".$host." identified by host (login=".$users[$l][$USERS_LOGIN].")\n";
			run_handlers("auth", $conn, $nick);
		}
	}
}

sub auth_user_byserv
{
	my ($conn, $nick) = @_;
	nickserv_status_nick($conn, $nick);
}

sub on_serv_auth
{
	my ($conn, $event, $nick, $level) = @_;
	my ($l, $n) = users_getuser($nick);

	if($level>=$SERV_MIN_STATUS_LEVEL) {
		$users[$l][$USERS_CURRENT][$n][$USERS_CIDENT]=$IDENT_BYSERV;
		print "[".localtime()."] "."user ".$nick." identified by services (login=".$users[$l][$USERS_LOGIN].")\n";
	}
	if($op_on_auth==1) {
		mode_push("+o", $nick);
		mode_sync($conn, $opchan_on_auth);
		$op_on_auth=0;
	}
	
}

1;
