#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

use strict;
use Net::IRC;
use Net::hostent;
use Socket;

	# global variables
use vars qw(@PLUGINST @COMMANDST @BHANDLERST @SERVANS $channels $nick $nickserv_pass $nickserv $services_up $op_on_auth $opchan_on_auth @deopchan_on_op
 @bots @commands @aliases @userlist @users $last_servans
 $PLUGINST_NAME $PLUGINST_ON $PLUGINST_INIT $PLUGINST_GETPARM $PLUGINST_CMDS $PLUGINST_HANDS
 $PLUGINST_OPTS $CMDS_NAME $CMDS_USAGE $CMDS_DESC $CMDS_FUNC $CMD_ID $CMD_NAME $SERV_TEXT $SERV_FUNC
 $USERL_CHAN $USERL_NICKS $USERL_NICK $USERL_FLAGS $USERL_ENDED $USER_VOICE $USER_OP
 $USERS_LOGIN $USERS_NICKS $USERS_HOSTS $USERS_CURRENT $USERS_CNICK $USERS_CIDENT $IDENT_BYHOST $IDENT_BYSERV
 $MAX_CONN_TIMEOUT $VERSION_REPLY
 );

# complete plugin table here
local @PLUGINST=(
	# name, on ?, init & getparams functions
	#	commands(name, usage, help, callback)
	#	handlers(name,	callback)
	#	options
	[
		"help", 0, \&help_init, \&help_getparams,
		[
			["help", "[<section>] <topic>", "display help on <topic> (in section <section>, 'all' is the default section)", \&cmd_help],
			["help-find", "<word>", "find <word> in the topic list", \&cmd_help_find],
			["help-add", "[<section>] <topic> <content>", "add a new topic to the help database (anybody can do this)", \&cmd_help_add],
			["help-sections", "", "lists help sections", \&cmd_help_sections],
			["help-admins", "", "lists help admins", \&cmd_help_admins],
			["help-rm", "[<section>] <topic>", "removes topic from help database (only for help admins)", \&cmd_help_rm],
			["help-mv", "[<section>] <topic> <new topic>", "renames topic from help database (only for help admins)", \&cmd_help_mv]
		],
		[],
		["helpdir", "sections", "default_section", "helpchans", "help_admins"]
	],
	[
		"phpbb", 0, \&phpbb_init, \&phpbb_getparams,
		[
			["forum", "<forum name>[::<thread>[::<number>]]", "show phpbb forums, a forum, or a thread", \&cmd_forum],
			["forum-unread", "", "list unread topics to the identified user", \&cmd_forum_unread],
			["forum-last", "[<n>]", "show last <n> topics", \&cmd_forum_last],
			["forum-url", "[<forum name>[::<thread>[::<number>]]]", "show url for the phpbb forums, forum or thread", \&cmd_forum_url],
			["forum-lasturl", "", "show url of the last post", \&cmd_forum_lasturl],
			["forum-post", "<forum name>::<topic> <text>", "post a message (only for identified users)", \&cmd_forum_post]
		],
		[
			["start", \&phpbb_on_start],
			["timer", \&phpbb_on_timer]
		],
		["db_sgdb", "db_name", "db_host", "db_user", "db_pass", "notice_chan", "baseurl"]
	],
	[
		"rrop", 0, \&rrop_init, \&rrop_getparams,
		[],
		[
			["timer", \&rrop_on_timer],
			["userlist_add", \&rrop_on_useradd],
			["userlist_del", \&rrop_on_userdel],
			["whoisidle", \&rrop_on_whoisidle],
			["disconnect", \&rrop_on_disconnect],
			["nosuchnick", \&rrop_on_nosuchnick],
		],
		["max_idle", "minnbops", "max_op", "max_op_servdwn", "op_world_serdwn", "channels", "nicks", "away_regexps"]
	],
);

# other declarations

my @HANDLERST=(
	# name		callback
	['376', 	\&on_connect],	# end of MOTD, connection OK
	['nicknameinuse',\&on_nick_in_use],
	['disconnect',	\&on_disconnect],
	['kick',	\&on_kick],
	['invite',	\&on_invite],
	['public',	\&on_msg],
	['msg',		\&on_msg],
	['notice',	\&on_notice],
	['namreply',	\&on_names],
	['join',	\&on_join],
	['quit',	\&on_quit],
	['part',	\&on_part],
	['mode',	\&on_mode],
	['nick',	\&on_nick],
	['whoisidle',	\&on_whoisidle],
	['whoreply',	\&on_whoreply],
	['endofnames',	\&on_endofnames],
	['cversion',	\&on_version],
	['',		\&on_unhandled]
);

local @BHANDLERST=(
	['reconnect',	\&on_reconnect],
	['conntimeout',	\&on_conntimeout],
	['servans',	\&on_servans],
);

local @SERVANS = (
	["\QPassword accepted - you are now recognized.\E", 	\&on_identified],
	["STATUS (.*) ([0-9])",					\&on_serv_auth]
);

my @GLOBOPTIONS = (
	'server',
	'channels',
	'chankey',
	'nick',
	'username',
	'ircname',
	'port',
	'nickserv_pass',
	'nickserv',
	'bots',
	'plugins'
);

local @COMMANDST= (
	["help", "[<command>]", "list commands and usages or get help on a specific command", \&cmd_bhelp]
);

	# chans' userlist
local @userlist=(
);

	# for authentification
local @users=(
);

my @PLUGCONFT= (
);

my ($cfg_dir, $server, $chankey, $username, 
 $ircname, $port, $helpdir, $conn, $irc);
# Multiple channels may be separated by ':' characters.
local ($nick, $channels, $nickserv_pass, $nickserv, $services_up, $op_on_auth,
 $opchan_on_auth, @deopchan_on_op, @commands, @aliases, @bots);
local $last_servans = time();

my $DEFAULT_CFG_FILE = "pbbot.conf";
my $COMMAND_CFG_FILE = "commands.conf";
my $ALIASES_CFG_FILE = "aliases.conf";
my $PLUGIN_CFG_FILE  = "plugin.conf";
my $USERS_CFG_FILE  = "users.conf";

my $TIMER_INTERVAL	= 90;

local $MAX_CONN_TIMEOUT	= 180; 		# 3 mn

local $VERSION_REPLY	= "PBBot last version by bennyben";

local $PLUGINST_NAME	= 0;
local $PLUGINST_ON	= 1;
local $PLUGINST_INIT	= 2;
local $PLUGINST_GETPARM	= 3;
local $PLUGINST_CMDS	= 4;
local $PLUGINST_HANDS	= 5;
local $PLUGINST_OPTS	= 6;

my $HANDLERST_NAME	= 0;
my $HANDLERST_FUNC	= 1;

local $SERV_TEXT	= 0;
local $SERV_FUNC	= 1;

local $CMD_ID		= 0;
local $CMD_NAME		= 1;

local $CMDS_NAME	= 0;
local $CMDS_USAGE	= 1;
local $CMDS_DESC	= 2;
local $CMDS_FUNC	= 3;

local $USERL_CHAN	= 0;
local $USERL_NICKS	= 1;
local $USERL_ENDED	= 2;
local $USERL_NICK	= 0;
local $USERL_FLAGS	= 1;
local $USER_VOICE	= 1;
local $USER_OP		= 2;

local $USERS_LOGIN	= 0;
local $USERS_NICKS	= 1;
local $USERS_HOSTS	= 2;
local $USERS_CURRENT	= 3;
local $USERS_CNICK	= 0;
local $USERS_CIDENT	= 1;
local $IDENT_BYHOST	= 1;
local $IDENT_BYSERV	= 2;



require("incs/config.ph");
require("incs/display.ph");
require("incs/mode.ph");
require("incs/plugins.ph");
require("incs/events.ph");
require("incs/services.ph");
require("incs/userlist.ph");
require("incs/users.ph");

# include your plugins here
require("plugins/help.ph");
require("plugins/phpbb.ph");
require("plugins/rrop.ph");


sub main {
		# Catch ctrl-c properly
	$SIG{INT}=sub {
		$conn->quit("No ! Don't Ctrl-C me ! Aaaaaahhhhhhhhh Interrupt");
		exit;
	};
	$SIG{TERM}=sub {
		$conn->quit("killed by f0king SIGTERM");
		exit;
	};
	$services_up=1;
	$op_on_auth=0;
	
	read_argv();
	read_globconfig();
	register_plugins();
	read_configs();
	register_irc_conn();
	register_handlers();
	start_timer();

	for(;;) {
		print "connecting...\n";
		$irc->start;
		print "disconnected.\n";
	}
}

sub read_argv
{
	$cfg_dir="./";
		# check command line arguments
	if($#ARGV>=0 && $ARGV[0] ne "") {
		$cfg_dir=$ARGV[0]."/";
	} elsif($#ARGV>=0) {
		print "usage: pbbot.pl [<configuration dir>]\n";
		exit 1;
	}
}

sub read_globconfig
{
	my $loadedplugs="";
	my $bt;
	
		# global options
	($server, $channels, $chankey, $nick, $username, $ircname, $port, $nickserv_pass, $nickserv, $bt, $loadedplugs) = read_config_from($cfg_dir.$DEFAULT_CFG_FILE, @GLOBOPTIONS);
	my @p = split(/,/, $loadedplugs);
	my $i;
	my $j;
	$bt =~ s/\s+//g;
	@bots = split(/,/, $bt);
		# activate wanted plugins
	for($i=0; $i<=$#p; $i++) {
		$p[$i] =~ s/^\s+//g;
		$p[$i] =~ s/\s+$//g;
		for($j=0; $j<=$#PLUGINST; $j++) {
			$PLUGINST[$j][$PLUGINST_ON]=1 if($PLUGINST[$j][$PLUGINST_NAME] eq $p[$i]);
		}
	}
		# global commands/aliases
	my @t=read_config_from($cfg_dir.$COMMAND_CFG_FILE, @COMMANDST);
	for($i=0; $i<=$#t; $i++) {
		$commands[$#commands+1][0]=$t[$i][0];
		$commands[$#commands][1]=$t[$i][1];
		$commands[$#commands][2]=$t[$i][2];
		$commands[$#commands][3]=$t[$i][3];
	}
#	push(@aliases, read_config_from($cfg_dir.$ALIASES_CFG_FILE, ()));
		 # users
	read_config($cfg_dir.$USERS_CFG_FILE, \&users_on_option_line);
}

sub read_configs
{
	my ($j, $i, $k);
	
		# foreach activated plugin
	for($k=0; $k<=$#PLUGINST; $k++) {
		if($PLUGINST[$k][$PLUGINST_ON]==1) {
				# read commands/aliases
			my @t;
			for($i=0; $i<=$#{$PLUGINST[$k][$PLUGINST_CMDS]}; $i++) {
				push(@t, $PLUGINST[$k][$PLUGINST_CMDS][$i][0]);
			}
			my @t2=read_config_from($cfg_dir.$PLUGINST[$k][$PLUGINST_NAME]."/".$COMMAND_CFG_FILE, @t);
			for($i=0; $i<=$#t2; $i++) {
				$commands[$#commands+1][0]=$t[$i];
				$commands[$#commands][1]=$t2[$i];
			}
#			push(@aliases, read_config_from($cfg_dir.$PLUGINST[$k][$PLUGINST_NAME]."/".$ALIASES_CFG_FILE, ()));

				# read plugin config & launch callback
			&{$PLUGINST[$k][$PLUGINST_GETPARM]}(read_config_from(
				$cfg_dir.$PLUGINST[$k][$PLUGINST_NAME]."/".$PLUGIN_CFG_FILE, @{$PLUGINST[$k][$PLUGINST_OPTS]}));
		}
	}
}

sub register_irc_conn
{
		# start connec
	$irc=Net::IRC->new;
	do {
		$conn=$irc->newconn(
		        Nick => $nick,
		        Server => $server,
		        Port => $port,
		        Username => $username,
		        Ircname => $ircname
		);
		if(!$conn) {
			print "[".localtime()."] Cannot connect, retrying in 10mn...\n";
			sleep(600);
		}
	} while (!$conn);
	# for debugging Net::IRC (and finding unhandled messages :)
	# $conn->debug(1);
}

sub register_handlers
{
		# register wanted handlers
	my $i;
	for($i=0; $i<=$#HANDLERST; $i++) {
		$conn->add_handler($HANDLERST[$i][$HANDLERST_NAME],
			$HANDLERST[$i][$HANDLERST_FUNC]);
	}
}

sub register_plugins
{
	my ($i, $j, $n);
	my $c=$#COMMANDST+1;
	
	print "loading plugins...";
	$n=0;
		# add commands to COMMANDST table
	for($i=0; $i<=$#PLUGINST; $i++) {
		for($j=0; $j<=$#{$PLUGINST[$i][$PLUGINST_CMDS]}; $j++) {
			if($PLUGINST[$i][$PLUGINST_ON]==1) {
				$COMMANDST[$c][0]=$PLUGINST[$i][$PLUGINST_CMDS][$j][0];
				$COMMANDST[$c][1]=$PLUGINST[$i][$PLUGINST_CMDS][$j][1];
				$COMMANDST[$c][2]=$PLUGINST[$i][$PLUGINST_CMDS][$j][2];
				$COMMANDST[$c++][3]=$PLUGINST[$i][$PLUGINST_CMDS][$j][3];
			}
		}
		if($PLUGINST[$i][$PLUGINST_ON]==1) {
			print $PLUGINST[$i][$PLUGINST_NAME]." ";
			&{$PLUGINST[$i][$PLUGINST_INIT]}();
			$n++;
		}
	}
	print "(".$n." plugins loaded)\n";
}

sub start_timer
{
		# start timer
	on_start();
	$SIG{ALRM} = sub { on_timer($conn); alarm $TIMER_INTERVAL; };
	alarm $TIMER_INTERVAL;
}

sub cmd_bhelp {
	my ($conn, $nick, $args)=@_;
	my ($i, $m, $n);
	
	
	if($args eq "") {
		$m="commands (channel or query): ";
		$n=0;
		foreach my $c (@commands) {
			foreach my $c2 (@COMMANDST) {
				if(@$c2[$CMDS_NAME] eq @$c[$CMD_ID]) {
					$m.=", " if($n!=0);
					$m.=@$c[$CMD_NAME];
					$m.=" " if(@$c2[$CMDS_USAGE] ne "");
					$m.=@$c2[$CMDS_USAGE];
					$n++;
				}
			}
		}
		$conn->privmsg($nick, $m);
	} else {
		$n=0;
		foreach my $c (@commands) {
			if(@$c[$CMD_NAME] eq $args) {
				foreach my $c2 (@COMMANDST) {
					if(@$c2[$CMDS_NAME] eq @$c[$CMD_ID]) {
						$m.=", " if($n!=0);
						$m.=@$c[$CMD_NAME];
						$m.=" " if(@$c2[$CMDS_USAGE] ne "");
						$m.=@$c2[$CMDS_USAGE]." - ".@$c2[$CMDS_DESC];
						$n++;
					}
				}
			}
		}
		$conn->privmsg($nick, $m) if($n>0);
	}
}

&main();
