#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

# constants
my $HELP_DIR	= "help";
my @sections=(
	"all"
);
my $default_section = "all";
my @helpchans=(
);
my @helpadmins=(
);

sub help_init
{
}

sub help_getparams
{
	my ($dir, $s, $defs, $hc, $ha)=@_;
	
	$HELP_DIR=$dir if($dir ne "");
	@sections=split(/,/, $s) if($s ne "");
	$default_section=$defs if($defs ne "");
	@helpchans=split(/,/, $hc) if($hc ne "");
	@helpadmins=split(/,/, $ha) if($ha ne "");
}

sub cmd_help
{
	my ($conn, $nick, $args) = @_;
	my ($i, $n);

	if($args ne "") {
		$n=0;
		my @w=split(/ /, $args);
		for($i=0; $i<=$#sections; $i++) {
			if($n==0 && $w[0] eq $sections[$i]) {
				msghelp($conn, $nick, $sections[$i], join(" ", splice(@w, 1)));
				$n++;
			}
		}
		msghelp($conn, $nick, $default_section, $args) if($n==0);
	}
}

sub cmd_help_find
{
	my ($conn, $nick, $args) = @_;

	if($args eq "") {
		privmsg($conn, $nick, "usage: !help-find <word>");
	} else {
		findhelp($conn, $nick, $args);
	}
}

sub cmd_help_sections
{
	my ($conn, $nick, $args) = @_;

	privmsgarr($conn, $nick, 1, @sections);
}

sub cmd_help_admins
{       
        my ($conn, $nick, $args) = @_;        
                        
        privmsgarr($conn, $nick, 1, @helpadmins);
}

sub cmd_help_add
{
	my ($conn, $nick, $args) = @_;
	my $n=0;

	if($args ne "") {
		my @w=split(/ /, $args);
		foreach my $s (@sections) {
			if($n==0 && $w[0] eq $s) {
				addhelp($conn, $nick, $s, $w[1], join(" ", splice(@w, 2)));
				$n++;
			}
		}
		addhelp($conn, $nick, $default_section, $w[0], join(" ", splice(@w, 1))) if($n==0);
	}
}

sub cmd_help_rm
{
	my ($conn, $nick, $args) = @_;
	my $n=0;
	my $authl=users_get_authlogin($nick);
	my $fn;

	foreach my $l (@helpadmins) {
		if($n==0 && $l eq $authl) {
			$n++;
			my $i=0;
			my @w=split(/ /, $args);
	                foreach my $s (@sections) {
        	                if($i==0 && $w[0] eq $s) {
					$fn=getfname($conn, $nick, $s, join(" ", splice(@w, 1)));
        	                        $i++;
        	                }
        	        }
			$fn=getfname($conn, $nick, $default_section, join(" ", splice(@w, 0))) if($i==0);
			return if($fn eq "");
			if(! -e $fn) {
				privmsg($conn, $nick, "this topic does not exists.");
			} else {
				unlink $fn;
			}
		}
	}
	privmsg($conn, $nick, "sorry, not identified.") if($authl eq "/");
	privmsg($conn, $nick, "sorry, identified but not an help admin.") if($authl ne "/" && $n==0);
}

sub cmd_help_mv
{
	my ($conn, $nick, $args) = @_;
        my $n=0;
        my $authl=users_get_authlogin($nick);
	my ($fn, $fn2);
                                    
        foreach my $l (@helpadmins) {       
                if($n==0 && $l eq $authl) {
                        $n++;
			my $i=0;
                        my @w=split(/ /, $args);
                        foreach my $s (@sections) {
                                if($i==0 && $w[0] eq $s) {
                                        $fn=getfname($conn, $nick, $s, $w[1]);
					$fn2=getfname($conn, $nick, $s, join(" ", splice(@w, 2)));
                                        $i++;
                                }
                        }
			if($i==0) {
                        	$fn=getfname($conn, $nick, $default_section, $w[0]);
				$fn2=getfname($conn, $nick, $default_section, join(" ", splice(@w, 1)));
			}
                        return if($fn eq "" || $fn2 eq "");
			if(! -e $fn) {
                                privmsg($conn, $nick, "this topic does not exists.");
			} elsif(-e $fn2) {
				privmsg($conn, $nick, "sorry, cannot overwrite an existing topic.");
                        } else {
                        	rename $fn,$fn2;
			}
                }
        }                     
        privmsg($conn, $nick, "sorry, not identified.") if($authl eq "/");
        privmsg($conn, $nick, "sorry, identified but not an help admin.") if($authl ne "/" && $n==0);
}

sub getfname
{
	my ($conn, $nick, $section, $fname) = @_;

	if($fname =~ /[A-Za-z\-_]*/) {
		my $n=0;
		
		foreach my $s (@sections) {
                	$n++ if($s eq $section);
        	}
		if($n==0) {
			privmsg($conn, $nick, "invalid section.");
			return "";
		}
	} else {
		privmsg($conn, $nick, "invalid file name.");
		return "";
	}
	return $HELP_DIR."/".$fname.".".$section;
}

sub msghelp {
	my ($conn, $nick, $section, $fname) = @_;
	my $line;
	my $i;
	my $r=0;
	my @res;
	my @arr;
	my $err="";

		# look first if it's a command, so we already answered
	foreach my $c (@commands) {
        	return if(@$c[$CMD_NAME] eq $fname);
	}

	my $fn=getfname($conn, $nick, $section, $fname);
	return if($fn eq "");
	open(HELPFILE, $fn) or $err="invalid topic.";
	if($err ne "") {
		privmsg($conn, $nick, $err);
		return;
	}
	while($line= <HELPFILE>) {
		chomp $line;
		@arr=split(/ /, $line);
		for($i=0; $i<=$#arr; $i++) {
			$res[$r++]=$arr[$i];
		}
	}
	close(HELPFILE);
	privmsgarr($conn, $nick, 0, @res);
}

sub addhelp
{
	my ($conn, $nick, $section, $fname, $content) = @_;
	my $err="";
	my $fn=getfname($conn, $nick, $section, $fname);
	my $n=0;
	
	return if($fn eq "");
	if(-e "$fn") {
		privmsg($conn, $nick, "this topic already exists.");
		return;
	}
	open(HELPFILE, ">".$fn);
	print HELPFILE "$content";
	close(HELPFILE);
}

sub findhelp {
	my ($conn, $nick, $find) = @_;
	my $err="";
	my $i;

	opendir(HELPD, $HELP_DIR) or $err="can't open help dir.";
	if($err ne "") {
		privmsg($conn, $nick, $err);
		return;
	}
	my @found = grep(/\Q$find\E/ && !/^\./, readdir(HELPD));
	for($i=0; $i<=$#found; $i++) {
		my @t=split /\./, $found[$i];
		my $ext=$t[$#t];
		$found[$i]=join(".", splice(@t, 0, $#t));
		$found[$i].=" (".$ext.")" if($ext ne $default_section);
	}
	if( $#found <0 || ($#found==0 && $found[0] eq "") ) {
		privmsg($conn, $nick, "not found.");
	} else {
		privmsgarr($conn, $nick, 1, @found);
	}
}

1;
