#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

use DBI;

my $err;

my $cid;

my ($phpbb_db_sgdb, $phpbb_db_name, $phpbb_db_host, $phpbb_db_user, $phpbb_db_pass);
my ($phpbb_noticechan, $phpbb_baseurl);

sub phpbb_init
{
}

sub phpbb_getparams
{
	my ($dbs, $dbn, $dbh, $dbu, $dbp, $nchan, $url)=@_;
	
	($phpbb_db_sgdb, $phpbb_db_name, $phpbb_db_host, $phpbb_db_user, $phpbb_db_pass, $phpbb_baseurl) =("","","","","", "");
	$phpbb_db_sgdb=$dbs if ($dbs ne "");
	$phpbb_db_name=$dbn if ($dbn ne "");
	$phpbb_db_host=$dbh if ($dbh ne "");
	$phpbb_db_user=$dbu if ($dbu ne "");
	$phpbb_db_pass=$dbp if ($dbp ne "");
	$phpbb_noticechan=$nchan if ($nchan ne "");
	$phpbb_baseurl=$url if($url ne "");
}

sub cmd_forum {
	my ($conn, $nick, $args) = @_;

	my $login=users_get_authlogin($nick);
        if($login eq "/") {
                privmsg($conn, $nick, "user not identified");
                return;
        }
	if($args eq "") {
		phpbb_forum_list($conn, $nick);
	} else {
		my @path=forumpath_to_arr($args);
		if($#path==0) {
			phpbb_topic_list($conn, $nick, $args);
		} elsif($#path==1) {
			phpbb_thread_list($conn, $nick, $path[0], $path[1]);
		} elsif($#path==2) {
			phpbb_thread_read($conn, $nick, $path[0], $path[1], $path[2]);
		} else {
			$conn->privmsg($nick, "unknown forum/topic/thread name");
		}
	}
}

sub cmd_forum_url
{
	my ($conn, $nick, $args) = @_;

	my $login=users_get_authlogin($nick);
        if($login eq "/") {
                privmsg($conn, $nick, "user not identified");
                return;
        }
	if($args eq "") {
		phpbb_forums_url($conn, $nick);
	} else {
		my @path=forumpath_to_arr($args);
		if($#path==0) {
			phpbb_forum_url($conn, $nick, $args);
                } elsif($#path==1 || $#path==2) {
                        phpbb_topic_url($conn, $nick, $path[0], $path[1]);
                } else {
                        $conn->privmsg($nick, "unknown forum/topic/thread name");
                }
	}
}

sub cmd_forum_lasturl
{
	my ($conn, $nick) = @_;

	my $login=users_get_authlogin($nick);
        if($login eq "/") {
                privmsg($conn, $nick, "user not identified");
                return;
        }
	phpbb_topic_lasturl($conn, $nick);
}

sub cmd_forum_unread {
	my ($conn, $nick, $args) = @_;

	my $login=users_get_authlogin($nick);
	if($login ne "/") {
		my @user=phpbb_auth($nick);
		if($#user<0) {
			$conn->privmsg($nick, "login unknown to forum");
		} else {
			phpbb_last_list($conn, $nick, $user[0][3], 0);
		}
	} else {
		$conn->privmsg($nick, "user not identified");
	}
}

sub cmd_forum_last {
	my ($conn, $nick, $args) = @_;
	my $n;

	my $login=users_get_authlogin($nick);
	if($login eq "/") {
		privmsg($conn, $nick, "user not identified");
		return;
	}
	if($args eq "") {
		phpbb_lastn($conn, $nick, 1);
	} elsif($args =~ /[0-9]*/) {
		phpbb_lastn($conn, $nick, $args);
	} else {
		$conn->privmsg($nick, "the argument is an number");
	}
}

sub cmd_forum_post
{
	my ($conn, $nick, $args) = @_;

	if($args eq "") {
		privmsg($conn, $nick, "must be arguments");
	} else {
		my @path=forumpath_to_arr($args);
		if($#path!=1) {
			privmsg($conn, $nick, "usage: <forum name>::<topic name> <text>");
			return;
		}
		my @rest=split(/ /, $path[1]);
		my $login=users_get_authlogin($nick);
		if($login eq "/") {
			privmsg($conn, $nick, "user not identified");
			return;
		}
		my @user=phpbb_auth($login);
		if($#user<0) {
			privmsg($conn, $nick, "login unknown to forum");
			return;
		}
		phpbb_post($conn, $nick, $login, $user[0][0], $path[0], $rest[0], join(" ", splice(@rest, 1)));
	}
}

sub forumpath_to_arr
{
	my ($args) = @_;
	my $j;

	my @path=split(/::/, $args);
        for($j=0; $j<=$#path; $j++) {
        	$path[$j] =~ s/\s+$//g;
        	$path[$j] =~ s/^\s+//g;
        }
	return @path;
}

sub phpbb_query
{
	my ($res, $query) = @_;
	my @row;

	my $dbh = DBI->connect("DBI:$phpbb_db_sgdb:dbname=$phpbb_db_name;host=$phpbb_db_host",
                $phpbb_db_user,  # user name
                $phpbb_db_pass,  # password
                { RaiseError => 0, PrintError => 1});
        if (!$dbh) { die "Cannot connect to database" }

	$err="";
	my $sth = $dbh->prepare($query) or $err="invalid query";
	$err="illegal query" if (!$sth);
	$sth->execute or $err="invalid query";
	return if($err ne "");
	my $i=0;
	while (@row = $sth->fetchrow_array) {
		my $m=$#row;
		my $j;
		for($j=0; $j<=$#row; $j++) {
			$res->[$i][$j]=$row[$j];
		}
		$i++;
	}
	$sth->finish;
	$dbh->disconnect;
}

sub phpbb_runquery
{
	my ($query) = @_;
        
        my $dbh = DBI->connect("DBI:$phpbb_db_sgdb:dbname=$phpbb_db_name;host=$phpbb_db_host",
                $phpbb_db_user,  # user name
                $phpbb_db_pass,  # password
                { RaiseError => 0, PrintError => 1});
        if (!$dbh) { die "Cannot connect to database" }

        $err="";
        my $sth = $dbh->prepare($query) or $err="invalid query";
        $err="illegal query" if (!$sth);
        $sth->execute or $err="invalid query";
        return if($err ne "");
	$sth->finish;
        $dbh->disconnect;
}


sub phpbb_get_last_ids
{
	my ($n) = @_;
	my @row;

	phpbb_query(\@row,
		"SELECT post_time FROM phpbb_posts ORDER BY post_id DESC LIMIT ".$n);
	return @row;
}

sub phpbb_get_last_id
{
	my @row = phpbb_get_last_ids 1;
	return $row[0][0];
}

sub phpbb_sqlquery_concat
{
	my (@tocat) = @_;
	my $res="";
	my $sep;
	
	if($phpbb_db_sgdb ne "Pg") {
		$res="CONCAT(";
		$sep=",";
	} else {
		$sep="||";
	}
	foreach $s (@tocat) {
		$res.=" ".$sep." " if($res ne "" && $res ne "CONCAT(");
		$res.=$s;
	}
	$res.=")" if($phpbb_db_sgdb ne "Pg");
	return $res;
}

sub phpbb_query_last
{
	my ($qend) = @_;

	my @row;
	phpbb_query(\@row,
		"SELECT post_time, ".phpbb_sqlquery_concat("forum_name","'::'","topic_title").", ".
		 phpbb_sqlquery_concat("username", "' posted \\\''", "post_subject", "'\\\''").", post_time, phpbb_posts.topic_id ".
		"FROM phpbb_topics, phpbb_forums, phpbb_posts, phpbb_posts_text, phpbb_users ".
		"WHERE phpbb_forums.forum_id=phpbb_topics.forum_id AND ".
			"phpbb_topics.topic_id=phpbb_posts.topic_id AND phpbb_users.user_id=phpbb_posts.poster_id AND ".
			"phpbb_posts_text.post_id=phpbb_posts.post_id ".$qend.";");
	return @row;
}

sub phpbb_lastn
{
	my ($conn, $nick, $n) = @_;

	my @row=phpbb_query_last("ORDER BY phpbb_posts.post_id DESC LIMIT ".$n);
	privmsgarr($conn, $nick, 5, @row) if($err eq "");
}

sub phpbb_last_list
{
	my ($conn, $nick, $last, $check) = @_;

	my @row=phpbb_query_last("AND post_time>".$last);
	if($err ne "" || $#row<0) {
		$conn->privmsg($nick, "no new message.") if($check==0);
		return $last;
	}
	print "found ".($#row+1)." new posts\n" if($check==1);
	privmsgarr($conn, $nick, 5, @row) if($err eq "");
	return $row[$#row][3];
}

sub phpbb_topic_lasturl
{
	my ($conn, $nick) = @_;
	my @row=phpbb_query_last("ORDER BY phpbb_posts.post_id DESC LIMIT 1");
	$conn->privmsg($nick, $phpbb_baseurl."/viewtopic.php?t=".$row[0][4]);
}

sub phpbb_auth
{
	my ($nick) = @_;
	my @row;

		# test: remplacement de session_time par lastvisit	
	phpbb_query(\@row,
		"SELECT user_id, user_email, user_website, user_session_time, user_lastvisit ".
		"FROM phpbb_users ".
		"WHERE username='".$nick."';");
	return @row;
}

sub phpbb_forum_list
{
	my ($conn, $nick) = @_;
	my @row;
	
	phpbb_query(\@row, 
		"SELECT forum_name FROM phpbb_forums ORDER BY forum_id");
	$conn->privmsg($nick, "error: ".$err) if($err ne "");
	privmsgarr($conn, $nick, 1, @row) if($err eq "");
}

sub phpbb_forums_url
{
	my ($conn, $nick) = @_;

	$conn->privmsg($nick, $phpbb_baseurl."/index.php");
}

sub phpbb_topic_list
{       
        my ($conn, $nick, $forum) = @_;
        my @row;
        
	$forum =~ s/\'/\\'/g;
        phpbb_query(\@row,
                "SELECT topic_title FROM phpbb_topics, phpbb_forums ".
		"WHERE phpbb_forums.forum_id=phpbb_topics.forum_id and forum_name='".$forum."' ORDER BY phpbb_forums.forum_id" );
	$conn->privmsg($nick, "error: ".$err) if($err ne "");
	privmsgarr($conn, $nick, 1, @row) if($err eq "");
}

sub phpbb_forum_url
{
	my ($conn, $nick, $forum) = @_;
	my @row;

	$forum =~ s/\'/\\'/g;
	phpbb_query(\@row,
		"SELECT forum_id FROM phpbb_forums ".
		"WHERE forum_name='".$forum."'");
	$conn->privmsg($nick, "error: ".$err) if($err ne "");
	if($#row<0) {
		$conn->privmsg($nick, "error: forum name not found");
	} else {
		$conn->privmsg($nick, $phpbb_baseurl."/viewforum.php?f=".$row[0][0]);
	}
}

sub phpbb_thread_list
{
	my ($conn, $nick, $forum, $thread) = @_;
	my @row;
	
	$forum =~ s/\'/\\'/g;
	$thread =~ s/\'/\\'/g;
	phpbb_query(\@row,
		"SELECT username,post_subject FROM phpbb_topics, phpbb_forums, phpbb_posts, phpbb_posts_text, phpbb_users ".
		"WHERE phpbb_forums.forum_id=phpbb_topics.forum_id AND forum_name='".$forum."' AND ".
			"phpbb_topics.topic_id=phpbb_posts.topic_id AND phpbb_users.user_id=phpbb_posts.poster_id AND ".
			"phpbb_posts_text.post_id=phpbb_posts.post_id AND topic_title='".$thread."' ".
		"ORDER BY post_time" );
	$conn->privmsg($nick, "error: ".$err) if($err ne "");
	privmsgarr($conn, $nick, 4, @row) if($err eq "");
}

sub phpbb_topic_url
{       
	my ($conn, $nick, $forum, $thread) = @_;
        my @row;

	$forum =~ s/\'/\\'/g;
        $thread =~ s/\'/\\'/g;
        phpbb_query(\@row,
		"SELECT topic_id FROM phpbb_topics, phpbb_forums ".
		"WHERE phpbb_forums.forum_id=phpbb_topics.forum_id AND forum_name='".$forum."' AND ".
			"topic_title='".$thread."'");
	$conn->privmsg($nick, "error: ".$err) if($err ne "");
        if($#row<0) {
                $conn->privmsg($nick, "error: topic not found");
	} else {
                $conn->privmsg($nick, $phpbb_baseurl."/viewtopic.php?t=".$row[0][0]);
        }
}


sub phpbb_thread_read
{
	my ($conn, $nick, $forum, $thread, $threadnum) = @_;
        my @row;
        
	$forum =~ s/\'/\\'/g;
	$thread =~ s/\'/\\'/g;
	my $limit="LIMIT ".($threadnum-1).",1";
	$limit="OFFSET ".($threadnum-1)." LIMIT 1" if($phpbb_db_sgdb eq "Pg"); 
        phpbb_query(\@row,
                "SELECT post_text,username,phpbb_posts.topic_id ".
		"FROM phpbb_topics, phpbb_forums, phpbb_posts, phpbb_posts_text, phpbb_users ".
                "WHERE phpbb_forums.forum_id=phpbb_topics.forum_id AND forum_name='".$forum."' AND ".
                        "phpbb_topics.topic_id=phpbb_posts.topic_id AND phpbb_users.user_id=phpbb_posts.poster_id AND ".
                        "phpbb_posts_text.post_id=phpbb_posts.post_id AND topic_title='".$thread."' ".
                "ORDER BY post_time ".$limit );
	if($#row==0) {
		if($err ne "") {
			$conn->privmsg($nick, "error: ".$err);
			return;
		}
		$msg=$row[0][0];
		$topiclink="\02(\02code at \x1F".$phpbb_baseurl."/viewtopic.php?t=".$row[0][2]."\x1F\02)\02";
		if($msg ne "") {
			$msg =~ s/\n/ /g;		# suppression des retours a la ligne
			$msg =~ s/\s+/ /g;		# suppression des doublons d'espaces
				# interprtation de code PHPBB
			$msg =~ s/\[u:[^\[]*\](([^\[]|\[[^u])*)\[\/u:[^\[]*\]/\x1F$1\x1F/g;				# urls
			$msg =~ s/\[url=([^\[]*)\](([^\[]|\[[^u])*)\[\/url\]/\x1F$1\x1F ($2)/g;
			$msg =~ s/\[url\](([^\[]|\[[^u])*)\[\/url\]/\x1F$1\x1F/g;
			$msg =~ s/\[img\:[^\[]*\](([^\[]|\[[^i])*)\[\/img\:[^\[]*\]/\02\(\02\x1F$1\x1F\02)\02/g;	# images
			$msg =~ s/\[quote\:[^\[]*\](([^\[]|\[[^q])*)\[\/quote\:[^\[]*\]/\02{\02$1\02}\02/g;		# quotes
			$msg =~ s/\:([a-z]+)\:/\02*$1*\02/g;								# smileys
			$msg =~ s/\[b\:[^\[]*\](([^\[]|\[[^b])*)\[\/b\:[^\[]*\]/$1/g;					# b= ?
			$msg =~ s/\[i\:[^\[]*\](([^\[]|\[[^i])*)\[\/i\:[^\[]*\]/$1/g;					# i = ?
			$msg =~ s/\[size=[^\[]*\](([^\[]|\[[^s])*)\[\/size:[^\[]*\]/$1/g;				# size= ?
			$msg =~ s/\[code\:[^\[]*\]([^\[]|\[[^c])*\[\/code\:[^\[]*\]/$topiclink/g;			# code
			$msg =~ s/\[list\:[^\[]*\](([^\[]|\[[^l])*)\[\/list[^\[]*\]/\02(\02$1\02)\02/g;			# lists
			$msg =~ s/\[list=[0-9]+\:[^\[]*\](([^\[]|\[[^l])*)\[\/list[^\[]*\]/\02(\02$1\02)\02/g;
			$msg =~ s/\[\*:[a-z0-9]+\]/\02\*\02 /g;								# list element
			$msg =~ s/&lt;/</g;
			$msg =~ s/&gt;/>/g;
		}
		privmsgarr($conn, $nick, 0, split(/ /, "\02[\02".$row[0][1]."\02]\02 ".$msg));
	} else {
		privmsg($conn, $nick, "");
	}
}

sub encode_ip
{
	my ($ip) = @_;

	if($ip =~ /([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)/) {
		return sprintf("%02x%02x%02x%02x", $1, $2, $3, $4);
	} else {
		return encode_ip("127.0.0.1");
	}
}

sub phpbb_post
{
	my ($conn, $nick, $login, $uid, $forum, $topic, $text) = @_;
	my @row;

	$forum =~ s/\'/\\'/g;
	$topic =~ s/\'/\\'/g;
	$text =~ s/\'/\\'/g;
	phpbb_query(\@row,
		"SELECT forum_id FROM phpbb_forums WHERE forum_name='".$forum."'");
	if($#row==0) {
		phpbb_post_from_forum($conn, $nick, $login, $uid, $forum, $topic, $text, $row[0][0]);
	} else {
		privmsg($conn, $nick, "forum name not found");
	}
}

sub phpbb_post_from_forum
{
	my ($conn, $nick, $login, $uid, $forum, $topic, $text, $forum_id) =@_;
	my @row;

	phpbb_query(\@row,
       		"SELECT topic_id FROM phpbb_topics WHERE forum_id=".$forum_id." AND topic_title='".$topic."'");
	if($#row!=0) {
		if($text =~ /^[ ]*$/) {
			privmsg($conn, $nick, "topic name not found");
			return;
		}
		my @ta=split(/ /, $text);
		phpbb_post_from_forum($conn, $nick, $login, $uid, $forum, $topic." ".$ta[0], join(" ", splice(@ta, 1)), $forum_id);
		return;
	}
	my $topic_id=$row[0][0];
        	# to find insert ID, just find the max+1 (and not use DB-dependant functions)
        phpbb_query(\@row,
                "SELECT max(post_id)+1 from phpbb_posts");
        my $post_id=0;
        $post_id=$row[0][0] if($#row==0);
                # TODO: find a better IP :)
        phpbb_runquery(
                "INSERT INTO phpbb_posts (post_id, topic_id, forum_id, poster_id, post_time, poster_ip)".
                " VALUES (".$post_id.", ".$topic_id.", ".$forum_id.", ".$uid.", ".time().", '".encode_ip("127.0.0.1")."')");
	my $substr="substr";
	$substr="substring" if($phpbb_db_sgdb ne "Pg");
        phpbb_runquery(
                "INSERT INTO phpbb_posts_text (post_id, bbcode_uid, post_subject, post_text)".
                " VALUES (".$post_id.", ".$substr."(md5('".rand()."'), 1, 10), '', '".$text."')");
	if($err ne "") {
		privmsg($conn, $nick, $err);
	} else {
		privmsg($conn, $nick, "message posted.");
	}
}

sub phpbb_on_start
{
	$cid=phpbb_get_last_id();
}

sub phpbb_on_timer
{
	my ($conn) = @_;

	$cid=phpbb_last_list($conn, $phpbb_noticechan, $cid, 1) if($phpbb_noticechan ne "");
}

1;
