#!/usr/bin/perl -w
#
# PBBot (Perl Bennyben's irc Bot)
# By bennyben (C) 2003 GPL Licence
#

#
# Round Robin Op for PBBot
#  Allows to assure a minimum of N active ops on a chan
#  and to set up a list of potential ops if needed (non-official ops)
#

# TODO: implement the has_to_op mechanism as a states machine

# constants
my $rrop_minnbops	= 2;
my $rrop_max_op		= 0;
my $rrop_max_op_servdwn	= 1;
my $rrop_op_world_servdwn = 0;
my $rrop_max_idle	= 900;	# 15mn
my @rrop_chans=(
);
my $RROP_LOGIN		= 0;
my $RROP_CHAN		= 1;
my $RROP_LEVEL		= 2;
my $RROP_MINLEVEL_OP	= 10;	# lower than 10 = will be deopped as possible
my $MAX_WHOIS_STEPS	= 10;	# 13 minutes = whois loop answer timeout
my @rrop_oplist=(
);
my @rrop_away_regexps=();

my @toop=();
my @todeop=();
my @deopchan_on_op=();
my $op_on_whois=0;
my $deop_on_whois=0;
my $deopped=0;
my $whois_timer=0;

sub rrop_init
{
}

sub rrop_getparams
{
	my ($max_idle, $minnbops, $max_op, $max_op_servdwn, $op_world_serdwn, $channels, $nicks, $reg)=@_;
	my ($i, $c, @nl, @nh);
	
	$rrop_max_idle=$max_idle if($max_idle ne "");
	$rrop_max_op=$max_op if($max_op ne "");
	$rrop_max_op_servdwn=$max_op_servdwn if($max_op_servdwn ne "");
	$rrop_op_world_serdwn=$op_world_serdwn if($op_world_serdwn ne "");
	$rrop_minnbops=$minnbops if($minnbops ne "");
		# string -> integer
	$rrop_max_idle+=0;$rrop_max_op+=0;$rrop_max_op_servdwn+=0;$rrop_op_world_serdwn+=0;$rrop_minnbops+=0;
	if($channels ne "") {
	 	$channels =~ s/\s+//g;
		@rrop_chans=split(/,/, $channels);
	}
	if($nicks ne "") {
		my @n=split(/,/, $nicks);
		$c=0;
		for($i=0; $i<=$#n; $i++) {
			@nl=split(/:/, $n[$i]);
			@nh=split(/@/, $nl[0]);
			$nh[0] =~ s/\s+//g;
			$nh[1] =~ s/\s+//g;
			$nl[1] =~ s/\s+//g;
			$rrop_oplist[$c][$RROP_LOGIN]=$nh[0];
			$rrop_oplist[$c][$RROP_CHAN]=$nh[1];
			$rrop_oplist[$c][$RROP_LEVEL]=$nl[1];
			$rrop_oplist[$c][$RROP_LEVEL]+=0;
			$c++;
		}
	}
	if($reg ne "") {
	 	$reg =~ s/\s+//g;
		@rrop_away_regexps=split(/,/, $reg);
	}
	disp_oplist();
}

sub disp_oplist
{
	my $i;
	
	print "[".localtime()."] "."oplist: ";
	for($i=0; $i<=$#rrop_oplist; $i++) {
		print $rrop_oplist[$i][$RROP_CHAN]."::".$rrop_oplist[$i][$RROP_LOGIN]."(".$rrop_oplist[$i][$RROP_LEVEL].") ";
	}
	print "\n";
}

sub rrop_on_timer
{
	my ($conn) = @_;
	my @op=();
	my @oppedna;
	
	print "[".localtime()."] "." rrop timer\n";
		# to avoid conflicts with on_userdel
	if($#toop!=-1 || $#todeop!=-1) {
		print "[".localtime()."] "."already whois-ing...no timer action\n";
		$whois_timer++;
		return if($whois_timer<$MAX_WHOIS_STEPS);
			# if there's too much time whe're waiting
		print "[".localtime()."] "." waited too much...FORCING\n";
	}
	$whois_timer=0;
	@toop=();
	@todeop=();
	@oppedna=();
		# build list to be whois-ed
	for($i=0; $i<=$#rrop_chans; $i++) {
		$chan=$rrop_chans[$i];
			# try to deop idle-ing ops
		@op=userlist_getops($chan);
			# here put level < 10 people
		@oppedna = rrop_getnonoff(@op);
			# add to array even if there's no op
		push(@todeop, ([$chan, [@op], $#op, [@oppedna]]) );
	}
	return if($#todeop==-1);
	print "[".localtime()."] "."launching idle check for ops...".($#todeop+1)." chans\n";
		# launch a queue, to check idle and op
	$deop_on_whois=1;
	$op_on_whois=0;
	$deopped=0;
		
	if($#{$todeop[0][1]}==-1) {
			# particular case, beginning with an opless chan
		rrop_on_end_deop($conn, $todeop[0][0]);
	} else {
			# whois first nick on the first chan
		$conn->whois($todeop[0][1][0]." ".$todeop[0][1][0]);
	}
}

sub rrop_replace_ops
{
	for($i=0; $i<=$#rrop_oplist; $i++) {
		@op=userlist_getops($rrop_oplist[$i][$RROP_CHAN]);
			# try to find missing ops again
		if($#op+1<$rrop_minnbops) {
				# only because idle can change
			rrop_build_finding_another_op($rrop_oplist[$i][$RROP_CHAN], 0, ());
		}
			# release all mode changes
		# TODO !?!?
	}
}

sub rrop_on_useradd
{
	my ($conn, $chan, $nick) = @_;
	my $i;
	
	for($i=0; $i<=$#rrop_oplist; $i++) {
			# if good chan & nick
		if($rrop_oplist[$i][$RROP_CHAN] eq $chan &&
		 $rrop_oplist[$i][$RROP_LOGIN] eq users_get_authlogin($nick)) {
			print "[".localtime()."] ".$nick." on ".$chan." identified, level=".$rrop_oplist[$i][$RROP_LEVEL]."\n";
		 		# if level > 10
			my @op=userlist_getops($chan);
			if($rrop_oplist[$i][$RROP_LEVEL] > $RROP_MINLEVEL_OP) {
					# can be op if wanted
				if($rrop_max_op==1 || 
				 ($rrop_max_op_servdow==1 && $services_up==0)) {
					print "[".localtime()."] ".$chan.": oping ".$nick." because he has right to\n";
					op_nick($conn, $chan, $nick);
				} elsif($#op+1<$rrop_minnbops) {
						# op only if there's a place
					print "[".localtime()."] ".$chan.": oping ".$nick." because there's a place for him in oplist (only ".($#op+1)." ops)\n";
					op_nick($conn, $chan, $nick) 
				}
			} elsif($#op+1<$rrop_minnbops) {
				print "[".localtime()."] ".$chan.": oping ".$nick." because there was only ".($#op+1)." ops\n";
				op_nick($conn, $chan, $nick);
			} elsif($rrop_op_world_serdwn==1 && $services_up==0) {
					# op even if level < 10 if services down
				print "[".localtime()."] ".$chan.": oping ".$nick." because services is down\n";
				op_nick($conn, $chan, $nick);
			}
		}
	}
}

sub rrop_on_userdel
{
	my ($conn, $chan, $nick, $flags) = @_;
	my @op=userlist_getops($chan);
	
	if($flags==$USER_OP && $#op+1<$rrop_minnbops) {
		rrop_build_finding_another_op($conn, $chan, 0, ());
		rrop_find_another_ops($conn);
	}
}

sub rrop_build_finding_another_op
{
	my ($conn, $chan, $only_off, @oppedna) = @_;
	my ($i, $j, @t, @t2, $c);
	
	print "[".localtime()."] "."trying to find another op...\n";
	$c=0;
	
	for($i=0; $i<=$#rrop_oplist; $i++) {
		if($rrop_oplist[$i][$RROP_CHAN] eq $chan) {
			@t=userlist_getnonops($chan);
			for($j=0; $j<=$#t; $j++) {
					# identified && official op if needed
				if($rrop_oplist[$i][$RROP_LOGIN] eq users_get_authlogin($t[$j])) {
				 	if($only_off==1 && $rrop_oplist[$i][$RROP_LEVEL]<=$RROP_MINLEVEL_OP) {
						print "[".localtime()."] ".$t[$j]." on ".$chan." login ".$rrop_oplist[$i][$RROP_LOGIN]." identified, but non-official, not added\n";
					} else {
						print "[".localtime()."] ".$t[$j]." on ".$chan." identified, on the chan, login=".$rrop_oplist[$i][$RROP_LOGIN]."\n";
						$t2[$c][0]=0+$rrop_oplist[$i][$RROP_LEVEL];
						$t2[$c++][1]=$t[$j];
					}
				}
			}
		}
	}
		# find number of ops to find
	@t=userlist_getops($chan);
	$c=$deopped+$rrop_minnbops-$#t-1;
	$c=1 if($c<1);
		# sort by level
	my @s=sort {${$b}[0] <=> ${$a}[0]} @t2;
		# if only official, we're sure we can set to 0 number of ops to find
	$c=0 if($only_off==1);
	push(@toop, ([$chan, [@s], $c, [@oppedna]] ));
print "[".localtime()."] "."launching toop func to find ".$c." ops (here's ".($#oppedna+1)." non-official ops)\n";
}

sub rrop_find_another_ops
{
	my ($conn) = @_;
# TODO: voir pkoi ici ya $#toop = 3...
print "[".localtime()."] "."flushing find, in queue: ".($#toop+1)." chans with first ".($#{$toop[0][1]}+1)." nicks\n";
	return if($#toop==-1);
	if($#{$toop[0][1]}==-1) {
			# anyway, if we have nothing to do, flush modes
		mode_sync($conn, $toop[0][0]);
		shift(@toop);
		return;
	}
	print "[".localtime()."] "."on chan ".$toop[0][0].", first nick to whois : ".$toop[0][1][0][1]."\n";
		# launch a queue, to check idle and op
	$op_on_whois=1;
		# whois first nick on the first chan
	$conn->whois($toop[0][1][0][1]." ".$toop[0][1][0][1]);
}

sub rrop_getnonoff
{
		# get authentified ops (which level >=10) and return the rest
	my (@list) = @_;
	my ($i, $j, $f, $login);
	my @ret;
	
	for($i=0; $i<=$#list; $i++) {
		$login=users_get_authlogin($list[$i]);
		$f=0;
		for($j=0; $j<=$#rrop_oplist; $j++) {
			$f=1 if($rrop_oplist[$j][$RROP_LOGIN] eq $login && $rrop_oplist[$j][$RROP_LEVEL] > $RROP_MINLEVEL_OP);
		}
		if($f==0) {
			print "[".localtime()."] "."on this chan, ".$list[$i]." is an non-official/non-authorized op\n";
			push(@ret, $list[$i]);
		}
	}
	return @ret;
}

sub rrop_is_not_away
{
	my ($nick) = @_;
	
	foreach my $reg (@rrop_away_regexps) {
		if($nick =~ /$reg/) {
			print "[".localtime()."] $nick seems to be away (matches /$reg/)\n";
			return 0;
		}
	}
	return 1;
}

sub rrop_on_end_deop
{
	my ($conn, $chan) = @_;
	my $only_off=0;
		# only op after if there's not enough op
	my $has_to_op=($todeop[0][2]+1-$deopped < $rrop_minnbops);
	print "[".localtime()."] "."on this chan, there is now (".($todeop[0][2]+1)." ops - ".$deopped." deopped ops)";
	if($has_to_op==1) {
		print ", = not enough, should be ".$rrop_minnbops." min ops\n";
	} else {
		if($#{$todeop[0][3]}!=-1) {
				# force to launch rrop_find_another_ops if we have non official ops
			$has_to_op=1;
			$only_off=1;
			print ", = enough, but there's ".($#{$todeop[0][3]}+1)." non-official ops\n";
		} else {
			print " = enough\n";
		}
	}

	rrop_build_finding_another_op($conn, $chan, $only_off, @{$todeop[0][3]}) if($has_to_op);
		# free todeop list
	shift(@todeop);
		# end of chan list ? only say for after
	if($#todeop==-1) {
		$deop_on_whois=0;
	}
		# has to op ?
	if($has_to_op) {
		rrop_find_another_ops($conn);
	} elsif($deop_on_whois==1) {
			# ok, continue with another chan (if we have one)
		$conn->whois($todeop[0][1][0]." ".$todeop[0][1][0]);
	} else {
		print "[".localtime()."] nothing to do, synchronizing modes\n";
		mode_sync($conn, $chan);
	}
}

sub rrop_on_whoisidle
{
	my ($conn, $nick, $idle) = @_;
	my $oping=$op_on_whois;
	
	print "[".localtime()."] ".$nick."'s idle: ".$idle." ".$op_on_whois."\n";
	if($idle<$rrop_max_idle && rrop_is_not_away($nick)) {
		if($op_on_whois==1) {
			print "[".localtime()."] ".$toop[0][0].": oping ".$nick." because one op as quit and his idle is good\n";
			mode_push("+o", $nick);
				# here if it's the case 'official op back', deop the non-offical op
				# and remove the non-official op to @oppedna
			if($#{$toop[0][3]}!=-1 && $toop[0][2]==0) {
				print "[".localtime()."] ".$toop[0][0].": deoping non official op ".$toop[0][3][0]."\n";
				mode_push("+v-o", $toop[0][3][0]." ".$toop[0][3][0]);
				shift(@{$toop[0][3]});
			} else {
				$toop[0][2]--;
			}
				# no op more to find (and no non-official op to deop)
			if($toop[0][2]<=0 && $#{$toop[0][3]}==-1) {
				$op_on_whois=0;
					# force end of nick list
				$toop[0][1]=([ [0, "test"] ]);
			}
		}
# TODO: go here if $deop_on_whois && it's a nick with 'OQP', 'Zzz', or 'away'
	} elsif($deop_on_whois==1 && $op_on_whois==0 &&
	 ($services_up==1 || $services_up==0 && $rrop_max_op_servdwn==0 && $rrop_op_world_servdwn==0)) {
		print "[".localtime()."] ".$todeop[0][0].": deoping ".$nick." because he's too big idle time\n";
			# remove him from @oppedna if needed
		my $i;
		my $j=-1;
		for($i=0; $i<=$#{$todeop[0][3]}; $i++) {
			if($todeop[0][3][$i] eq $nick) {
				$j=$i;
			}
		}
		if($j!=-1) {
			print "[".localtime()."] ".$todeop[0][0].": removing ".$nick." from non-official ops\n";
			splice(@{$todeop[0][3]}, $j, 1);
		}
		mode_push("+v-o", $nick." ".$nick);
		$deopped++;
	}
	do_next_whois($conn, $oping);
}

sub do_next_whois
{
	my ($conn, $oping) = @_;
	
	if($oping==1) {
print "[".localtime()."] "."[op]\n";
		my $chan=$toop[0][0];
		shift(@{$toop[0][1]});
		
			# end of nick list ?
		if($#{$toop[0][1]}==-1) {
			mode_sync($conn, $chan);
			shift(@toop);
				# end of chan list ?
			if($#toop==-1) {
print "[".localtime()."] "."end of op todo, continueing deop\n";
				$op_on_whois=0;
				$deopped=0;
				if($deop_on_whois==1) {
# TODO -> comprendre ici ??? apres deop puis op... -> tester avec un chan sans ops !
						# opless chan
					if($#{$todeop[0][1]}==-1) {
						rrop_on_end_deop($conn, $chan);
					} else {
							# continue to deop
						$conn->whois($todeop[0][1][0]." ".$todeop[0][1][0]);
					}
				}
			} else {
					# continue with another nick on another chan
				$conn->whois($toop[0][1][0][1]." ".$toop[0][1][0][1]);
			}
		} else {
				# continue with another nick
			$conn->whois($toop[0][1][0][1]." ".$toop[0][1][0][1]);
		}
	} else {
print "[".localtime()."] "."[deop]\n";
		my $chan=$todeop[0][0];
		shift(@{$todeop[0][1]});
		
			# end of nick list ?
		if($#{$todeop[0][1]}==-1) {
print "[".localtime()."] "."end of deop chan ".$chan.", trying to op, deopped: ".$deopped."\n";
			rrop_on_end_deop($conn, $chan);
		} else {
				# continue with another nick
			$conn->whois($todeop[0][1][0]." ".$todeop[0][1][0]);
		}
	}
}

sub rrop_on_nosuchnick
{
	my ($conn, $nick) = @_;
	
	return if($op_on_whois==0 && $deop_on_whois==0);
	print $nick.": NO such nick, skipping, next whois\n";
	do_next_whois($conn, $op_on_whois);
}

sub rrop_on_disconnect
{
	$op_on_whois=0;
	$deop_on_whois=0;
	$deopped=0;
	@toop=();
	@todeop=();
}

1;
